<template>
  <div class="kit add review">
    <form
      v-if="!complete"
      action=""
      class="review-form">
      <div class="review-header">
        <span v-if="auth && auth.isOrganization">
          <img
            svg-inline
            src="~/assets/svg/law-big.svg"
            alt="">

        </span>
        <span v-else>
          <img
            svg-inline
            src="~/assets/svg/privat.svg"
            alt="">
        </span>
        <div class="user-name">{{ name }}
        </div>
        <slot name="header"/>
        <multiselect
          v-if="!isAbuse"
          class="no-checkbox"
          v-model="value"
          :options="shopic"
          :allow-empty="false"
          :searchable="false"
          :show-labels="true"
          :preselect-first="true"
          track-by="id"
          label="shop_name"/>
      </div>
      <div class="review-main">
        <textarea
          class="form-control"
          :class="{invalid: validation.hasError('formData.comment')}"
          v-model="formData.comment"
          name=""
          id=""
          cols="30"
          rows="10"
          :placeholder="placeholder"/>
        <div class="message">{{ validation.firstError('formData.comment') }}</div>
        <div class="message">{{ validation.firstError('rating') }}</div>
      </div>
      <div
        class="review-footer"
        :class="{'flex-end': isAbuse}">
        <div
          class="text rating-comment"
          v-if="hasRating">
          <span> Оценка:</span>
          <rating
            :read-only="readOnly"
            @rating-selected="setRating"/>
        </div>

        <button
          class="ui button"
          v-if="!complete"
          @click.prevent="sendFeedback">Отправить</button>
      </div>
    </form>
    <div
      v-if="complete"
      class="success-message">
      <img
        svg-inline
        src="~/assets/images/check-circular.svg"
        alt="">
      <span class="success-message__text">
        {{ successMessage }}
      </span>
    </div>
  </div>
</template>

<script>
// TODO: Tech debt. Сделать общий компонент формы feedback.
// И два отдельных компонента abuse и комментарии с рейтингом
import { createNamespacedHelpers } from 'vuex';
import SimpleVueValidation from 'simple-vue-validator';
import Multiselect from 'vue-multiselect';
import Rating from '~/components/blocks/rating';
import Vue from 'vue';

const STORE_USER = createNamespacedHelpers('user');
const SimpleVueValidator = SimpleVueValidation.Validator;

Vue.use(SimpleVueValidation, {
  mode: 'manual',
});
export default {
  name: 'FeedbackBlock',
  components: {
    Multiselect,
    Rating,
  },
  mixins: [SimpleVueValidation.mixin],
  props: {
    shopFilial: {
      type: Array,
      default() { return []; },

    },
    shop: {
      type: Object,
      default() { return {}; },
    },
    user: {
      type: Object,
      default() { return {}; },

    },
    readOnly: {
      type: Boolean,
      default: false,
    },
    hasRating: {
      type: Boolean,
      default: false,
    },
    placeholder: {
      type: String,
      default: '',
    },
    type: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      value: '',
      rating: 0,
      complete: false,
      formData: {
        comment: '',
      },
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    isAbuse() {
      return this.type === 'abuse';
    },
    isComment() {
      return this.type === 'comment';
    },
    name() {
      const name = [];

      if (this.auth && this.auth.userProfile) {
        this.auth.userProfile.firstName && name.push(this.auth.userProfile.firstName);
        this.auth.userProfile.middleName && name.push(this.auth.userProfile.middleName);
        this.auth.userProfile.lastName && name.push(this.auth.userProfile.lastName);

        return name.length && name.join(' ');
      }

      return 'Гость';
    },
    shopic() {
      const originalShop = [
        {
          shop_name: this.shop.shop_name,
        },
      ];
      return this.shopFilial.concat(originalShop);
    },
    successMessage() {
      if (this.isComment) {
        return 'Ваш отзыв отправлен на модерацию. После проверки он будет размещён на сайте.';
      }

      if (this.isAbuse) {
        return 'Спасибо за ваше обращение, жалоба будет рассмотрена в ближайщее время.';
      }

      return '';
    },
  },
  validators: {
    'formData.comment'(value) {
      const text = this.isComment
        ? 'отзыв'
        : 'жалобу';

      return SimpleVueValidator
        .value(value)
        .custom(() => !value.trim() && `Напишите ${text}`);
    },
    rating(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => (!value && this.isComment) && 'Для отправки отзыва укажите рейтинг');
    },
  },
  methods: {
    setRating(rating) {
      this.rating = rating;
    },
    hideTimer(interval = 5000) {
      setTimeout(() => {
        this.complete = false;
        this.$emit('send-feedback');
      }, interval);
    },
    resetFeedback() {
      this.validation.reset();
      this.formData.comment = '';
      this.rating = 0;
    },
    getRequestUrl() {
      return this.isComment
        ? '/_main/feedback/create'
        : '/_main/abuse/create';
    },
    getRequestData() {
      // TODO: recipientUserId: Number(this.user.id) user тут не тот же что и auth.
      return this.isComment
        ? {
          data: {
            comment: this.formData.comment,
            rating: this.rating,
            recipientUserId: Number(this.user.id),
          },
        }
        : {
          shopId: Number(this.shop.id),
          comment: this.formData.comment,
        };
    },
    async sendFeedback() {
      const isValid = await this.$validate();

      if (!isValid) {
        return;
      }

      this.loading = true;

      try {
        await this.$axios.$post(this.getRequestUrl(), this.getRequestData());
        this.resetFeedback();
        this.complete = true;
        this.hideTimer();
        this.loading = false;
      } catch (e) {
        this.resetFeedback();
        this.loading = false;
        console.error(e);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
  .kit.add.review {
    height: 32rem;
    padding: 18px 44px;
    width: 100%;
    @media screen and (max-width: 1024px) {
      height: auto;
      border-top: 1px solid #9aacb7;
    }

    .review-form {
      width: 100%;

      .review-header {
        position: relative;

        .svg {
          top: 16px;
          left: 0px;
          position: absolute;
          margin-right: 8px;
          width: 2.875rem;
          height: 2.875rem;
          border-radius: 100%;
        }

        .user-name {
          margin-bottom: 28px;
          padding: 32px 0 0 60px;
          line-height: 13px;
        }

        label {
          font-size: 13px;
          line-height: 11px;
          font-weight: 500;
        }

        .shopname {
          font-weight: 400;
          padding-left: 16px;
        }
      }

      .review-main {
        margin-top: 11px;
        margin-bottom: 16px;
        width: 100%;

        .form-control {
          padding: 8px 16px;
          width: 100%;
          resize: none;

          &.invalid {
            border-color: #e13c3c;
            outline: none;
          }
        }
      }

      .review-footer {
        display: flex;
        justify-content: space-between;
        align-items: center;

        &.flex-end {
          justify-content: flex-end;
        }

        @media screen and (max-width: 450px) {
          justify-content: center;
          flex-direction: column;
        }

        .text.rating-comment {
          display: flex;
          width: 100%;

          @media screen and (max-width: 450px) {
            justify-content: center;
            align-items: center;
            padding-bottom: 20px;
          }

          span {
            padding-right: 11px;
          }

        }

        .ui.button {
          color: #272727;
          background-color: transparent;
          border: 1px solid #4272a4;

          &:hover {
            color: #fff;
            background-color: #345a81;
          }
        }
      }
    }

    .success-message {
      font-size: 1rem;
      display: flex;
      justify-content: center;
      align-items: center;

      & > .svg{
        margin-right: 24px;
      }

      &__text {
        max-width: 290px;
      }
    }
    .message{
      text-align: center;
      padding: 2px 0px;
      width: 100%;
      display: block;
      font-size: 13px;
      color: #FF0000;
    }
  }
</style>
